/**
 * @package Sj Categories Full
 * @version 2.5
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 * 
 */

(function($) {
	$.fn.jsmartCategoriesFull= function(settings) {
		var config = {
			changeSpeed :600,
			controls : true,
			controlText : { next :'Next', previous :'Previous'},
			effect : 'fade',
			button : true,
			speed : 3000
		};
		if (settings) $.extend(true, config, settings);
		if (config.speed < (config.changeSpeed+20)) {
			alert('');
			return this;
		};
		this.each(function(i) {
			var $cont = $(this);
			var gallery = $(this).children().remove();
			var timer = '';
			var counter = 0;
			var preloadedImg = [];
			var howManyInstances = $('.list').length+1;
			var uniqueClass = 'list-'+howManyInstances;
			var cssClass = config.cssClass != undefined ? config.cssClass : '';
			$cont.css('position','relative').wrap('<div class="list '+uniqueClass+'" />');
			$cont.removeClass('no-change');
			var $wrap = $('.'+uniqueClass);
		
			$wrap.css('position','relative').addClass(cssClass);
			$(gallery[0]).clone().appendTo($cont);
			preloadImg();
			if(config.controls){
				addControls();
			};
			
			if(config.button){
				addDirection();
				$('.'+uniqueClass+'-button li').eq(0).addClass(uniqueClass+'-active list-active');
			};
			if(gallery.length<1){
				$('.'+uniqueClass).append('');
			};
			function transitionTo(gallery,index) {				
				var oldCounter = counter;
				if((counter >= gallery.length) || (index >= gallery.length)) { counter = 0; var e2b = true; }
				else if((counter < 0) || (index < 0)) { counter = gallery.length-1; var b2e = true; }
				else { counter = index; }
				if(config.effect=='slideLeft'){
					var newSlideDir, oldSlideDir;
					function slideDir(dir) {
						newSlideDir = dir=='right' ? 'left' : 'right';
						oldSlideDir = dir=='left' ? 'left' : 'right';					
					};					
					counter >= oldCounter ? slideDir('left') : slideDir('right') ;
					$(gallery[counter]).clone().appendTo($cont).slideIt({direction:newSlideDir,changeSpeed:config.changeSpeed});
					if($cont.children().length>1){
						$cont.children().eq(0).css('position','absolute').slideIt({direction:oldSlideDir,showHide:'hide',changeSpeed:config.changeSpeed},function(){$(this).remove();});
					};
				} else if (config.effect=='fade') {
					$(gallery[counter]).clone().appendTo($cont).hide().fadeIn(config.changeSpeed,function(){if($.browser.msie)this.style.removeAttribute('filter');});
					if($cont.children().length>1){
						$cont.children().eq(0).css('position','absolute').fadeOut(config.changeSpeed,function(){$(this).remove();});
					};
				} else if (config.effect=='none') {
					$(gallery[counter]).clone().appendTo($cont);
					if($cont.children().length>1){
						$cont.children().eq(0).css('position','absolute').remove();
					};
				};
				if(config.button){
					$('.'+uniqueClass+'-active').removeClass(uniqueClass+'-active list-active');
					$('.'+uniqueClass+'-button li').eq(counter).addClass(uniqueClass+'-active list-active');
				};
			};
			function next() {
				goToAndPause(counter+1);
			};
			function previous() {
				goToAndPause(counter-1);
			};
			function isBusy() {
				return $cont.children().length>1 ? true : false;
			};
			function goToAndPause(index) {
				$cont.children().stop(true,true);
				if((counter != index) || ((counter == index) && isBusy())){
					if(isBusy()) $cont.children().eq(0).remove();
					transitionTo(gallery,index);
				};
			};	
			function preloadImg() {
				$(gallery).each(function(i){
					$(this).find('img').each(function(i){
						preloadedImg[i] = $('<img>').attr('src',$(this).attr('src'));					
					});
				});
			};
			function addDirection() {
				$wrap.append('<ul class="list-button '+uniqueClass+'-button"></ul>');
				$.each(gallery, function(i, val) {
					var linktext = $(this).attr('title') != '' ? $(this).attr('title') : i+1;
					$('<li class="list-button-'+i+'" >'+linktext+'</li>').bind('click', {index:i}, function(e){ goToAndPause(e.data.index); return false; }).appendTo('.'+uniqueClass+'-button');
				});
			};		
			function addControls() {
				$wrap.append('<ul class="list-controls '+uniqueClass+'-controls"><li class="list-prev '+uniqueClass+'-prev" >'+config.controlText.previous+'</li> <li class="list-next '+uniqueClass+'-next" >'+config.controlText.next+'</li></ul>');
				$('.'+uniqueClass+'-controls li').each(function(){							
							if($(this).hasClass('list-prev')) $(this).click(function(){ previous(); return false; });
							if($(this).hasClass('list-next')) $(this).click(function(){ next(); return false; });
		
				});
			};	
		});
	
		return this;
	};

})($jsmart||jQuery);

(function($) {

	$.fn.slideIt = function(settings,callback) {
		var config = {
			direction : 'left',
			showHide : 'show',
			changeSpeed : 600
		};
		if (settings) $.extend(config, settings);
		
		this.each(function(i) {	
			$(this).css({left:'auto',right:'auto',top:'auto',bottom:'auto'});
			var measurement = (config.direction == 'left') || (config.direction == 'right') ? $(this).outerWidth() : $(this).outerHeight();
			var startStyle = {};
			startStyle['position'] = $(this).css('position') == 'static' ? 'relative' : $(this).css('position');
			startStyle[config.direction] = (config.showHide == 'show') ? '-'+measurement+'px' : 0;
			var endStyle = {};
			endStyle[config.direction] = config.showHide == 'show' ? 0 : '-'+measurement+'px';
			$(this).css(startStyle).animate(endStyle,config.changeSpeed,callback);
		});	
		return this;
	};
})($jsmart||jQuery);