<?php
/**
 * @package Sj Zoo Categories Full
 * @version 2.5
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 * 
 */
defined('_JEXEC') or die;

if (!class_exists('ZooCategoriesFullReader')){
	class ZooCategoriesFullReader extends SjReader{
		public function getList(&$params){
			$list =array();			
			$categories = array();	
			 $category_ids = $this->zoo->getPublishedCategories($params);			
			 if(!empty($category_ids)){
				 foreach($category_ids as $cid){
					$category = $this->zoo->getCategory($cid);
					$category->title = $category->title;					
					$category->link = JRoute::_('index.php?option=com_zoo&task=category&category_id='.$cid);
					 if (!isset($category->image_extracted)){
								$category_images = YTools::extractImages($category->description);
								$category->image_extracted = true;
					 }							
					 if (!isset($category->image)){					
						 foreach ($category_images as $i => $image_url) {
							if (YTools::isUrl($image_url) || file_exists($image_url)){
								$category->image = $image_url;
								break;
								}
							}
						}
					 if (!isset($category->image) || (!YTools::isUrl($category->image) && !file_exists($category->image))){
						 $category->image = 'modules/'.Ytools::getModule()->module . '/assets/images/nophoto.png';
					  }
					  $category->child= $this->itemsForCategory($cid, $params);					 					  
				$list[$cid]=$category;					
				}
			}	
			return $list;
		}
		
		private function itemsForCategory($category_id, $params){
			$items=array();			
			$list_item = $this->zoo->getCategoryItems($category_id, $params);				
			if(!empty($list_item)) {			
				$arrcustom_url=array();
				$arrcustom_url = $this->_getCustomUrl($params['custom_url']);
				foreach($list_item as $key => $item){				
					$this->zoo->getItemDescription($item,$params);						
					if (!$this->zoo->getItemImage($item,$params)){
						$image_url = 'modules/' . YTools::getModule()->module . '/assets/images/nophoto.png';					
						$item->image =$image_url;
					
					}											
					if(array_key_exists($item->id, $arrcustom_url)){
						$item->link = $arrcustom_url[$item->id];					
					} else {
						$item->link = $this->zoo->getItemUrl($item);
					}
					$item->created=JHTML::_('date', $item->created, JText::_('DATE_FORMAT_LC3'));	
					
				$items[]=$item; 
				}
		 }	
			return $items;
	 }				
		private function _getCustomUrl($custom_url) {
			$arrUrl = array();
			$tmp = explode("\n", trim($custom_url));
			foreach( $tmp as $strTmp){
				$pos = strpos($strTmp, ":");
				if($pos >=0){
					$tmpKey = substr($strTmp, 0, $pos);
					$key = trim($tmpKey);
					$tmpLink = substr($strTmp, $pos+1, strlen($strTmp)-$pos);
					$haveHttp =  strpos(trim($tmpLink), "http://");
					if($haveHttp<0 || ($haveHttp !== false) ){
						$link = trim($tmpLink);
					}else{
						$link = "http://" . trim($tmpLink);
					}
					$arrUrl[$key] = $link;
				}
			}
			return $arrUrl;
		}	
	}	
}